org.apache.lucene.index

## Class SlowCompositeReaderWrapper

- java.lang.Object
- - org.apache.lucene.index.IndexReader
  - - org.apache.lucene.index.AtomicReader
    - - org.apache.lucene.index.SlowCompositeReaderWrapper

All Implemented Interfaces:
  Closeable, AutoCloseable

    public final class SlowCompositeReaderWrapper
    extends AtomicReader

This class forces a composite reader (eg a `MultiReader` or `DirectoryReader`) to emulate an atomic reader. This requires implementing the postings APIs on-the-fly, using the static methods in `MultiFields`, `MultiDocValues`, by stepping through the sub-readers to merge fields/terms, appending docs, etc.

NOTE: this class almost always results in a performance hit. If this is important to your use case, you'll get better performance by gathering the sub readers using `IndexReader.getContext()` to get the atomic leaves and then operate per-AtomicReader, instead of using this class.

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.lucene.index.IndexReader

`IndexReader.ReaderClosedListener`

### Constructor Summary

Constructors
Constructor and Description
`SlowCompositeReaderWrapper(CompositeReader reader)` Sole constructor, wrapping the provided `CompositeReader`.

### Method Summary

Methods
`protected void` `doClose()` Implements close.
`void` `document(int docID, StoredFieldVisitor visitor)` Expert: visits the fields of a stored document, for custom processing/loading of each field.
`Fields` `fields()` Returns `Fields` for this reader.
`BinaryDocValues` `getBinaryDocValues(String field)` Returns `BinaryDocValues` for this field, or null if no `BinaryDocValues` were indexed for this field.
`Object` `getCombinedCoreAndDeletesKey()` Expert: Returns a key for this IndexReader that also includes deletions, so FieldCache/CachingWrapperFilter can find it again.
`Object` `getCoreCacheKey()` Expert: Returns a key for this IndexReader, so FieldCache/CachingWrapperFilter can find it again.
`FieldInfos` `getFieldInfos()` Get the `FieldInfos` describing all fields in this reader.
`Bits` `getLiveDocs()` Returns the `Bits` representing live (not deleted) docs.
`NumericDocValues` `getNormValues(String field)` Returns `NumericDocValues` representing norms for this field, or null if no `NumericDocValues` were indexed.
`NumericDocValues` `getNumericDocValues(String field)` Returns `NumericDocValues` for this field, or null if no `NumericDocValues` were indexed for this field.
`SortedDocValues` `getSortedDocValues(String field)` Returns `SortedDocValues` for this field, or null if no `SortedDocValues` were indexed for this field.
`SortedSetDocValues` `getSortedSetDocValues(String field)` Returns `SortedSetDocValues` for this field, or null if no `SortedSetDocValues` were indexed for this field.
`Fields` `getTermVectors(int docID)` Retrieve term vectors for this document, or null if term vectors were not indexed.
`boolean` `hasDeletions()` Returns true if any documents have been deleted
`int` `maxDoc()` Returns one greater than the largest possible document number.
`int` `numDocs()` Returns the number of documents in this index.
`String` `toString()`
`static AtomicReader` `wrap(IndexReader reader)` This method is sugar for getting an `AtomicReader` from an `IndexReader` of any kind.

### Methods inherited from class org.apache.lucene.index.AtomicReader

`docFreq, getContext, hasNorms, termDocsEnum, termPositionsEnum, terms, totalTermFreq`

### Methods inherited from class org.apache.lucene.index.IndexReader

`addReaderClosedListener, close, decRef, document, document, ensureOpen, equals, getRefCount, getTermVector, hashCode, incRef, leaves, numDeletedDocs, open, open, open, open, open, registerParentReader, removeReaderClosedListener, tryIncRef`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### SlowCompositeReaderWrapper

    public SlowCompositeReaderWrapper(CompositeReader reader)
                               throws IOException

Sole constructor, wrapping the provided `CompositeReader`.

Throws:
  `IOException`

### Method Detail

#### wrap

    public static AtomicReader wrap(IndexReader reader)
                             throws IOException

This method is sugar for getting an `AtomicReader` from an `IndexReader` of any kind. If the reader is already atomic, it is returned unchanged, otherwise wrapped by this class.

Throws:
  `IOException`

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`

#### fields

    public Fields fields()

Description copied from class: `AtomicReader`
Returns `Fields` for this reader. This method may return null if the reader has no postings.

Specified by:
  `fields` in class `AtomicReader`

#### getNumericDocValues

    public NumericDocValues getNumericDocValues(String field)
                                         throws IOException

Description copied from class: `AtomicReader`
Returns `NumericDocValues` for this field, or null if no `NumericDocValues` were indexed for this field. The returned instance should only be used by a single thread.

Specified by:
  `getNumericDocValues` in class `AtomicReader`
Throws:
  `IOException`

#### getBinaryDocValues

    public BinaryDocValues getBinaryDocValues(String field)
                                       throws IOException

Description copied from class: `AtomicReader`
Returns `BinaryDocValues` for this field, or null if no `BinaryDocValues` were indexed for this field. The returned instance should only be used by a single thread.

Specified by:
  `getBinaryDocValues` in class `AtomicReader`
Throws:
  `IOException`

#### getSortedDocValues

    public SortedDocValues getSortedDocValues(String field)
                                       throws IOException

Description copied from class: `AtomicReader`
Returns `SortedDocValues` for this field, or null if no `SortedDocValues` were indexed for this field. The returned instance should only be used by a single thread.

Specified by:
  `getSortedDocValues` in class `AtomicReader`
Throws:
  `IOException`

#### getSortedSetDocValues

    public SortedSetDocValues getSortedSetDocValues(String field)
                                             throws IOException

Description copied from class: `AtomicReader`
Returns `SortedSetDocValues` for this field, or null if no `SortedSetDocValues` were indexed for this field. The returned instance should only be used by a single thread.

Specified by:
  `getSortedSetDocValues` in class `AtomicReader`
Throws:
  `IOException`

#### getNormValues

    public NumericDocValues getNormValues(String field)
                                   throws IOException

Description copied from class: `AtomicReader`
Returns `NumericDocValues` representing norms for this field, or null if no `NumericDocValues` were indexed. The returned instance should only be used by a single thread.

Specified by:
  `getNormValues` in class `AtomicReader`
Throws:
  `IOException`

#### getTermVectors

    public Fields getTermVectors(int docID)
                          throws IOException

Description copied from class: `IndexReader`
Retrieve term vectors for this document, or null if term vectors were not indexed. The returned Fields instance acts like a single-document inverted index (the docID will be 0).

Specified by:
  `getTermVectors` in class `IndexReader`
Throws:
  `IOException`

#### numDocs

    public int numDocs()

Description copied from class: `IndexReader`
Returns the number of documents in this index.

Specified by:
  `numDocs` in class `IndexReader`

#### maxDoc

    public int maxDoc()

Description copied from class: `IndexReader`
Returns one greater than the largest possible document number. This may be used to, e.g., determine how big to allocate an array which will have an element for every document number in an index.

Specified by:
  `maxDoc` in class `IndexReader`

#### document

    public void document(int docID,
                StoredFieldVisitor visitor)
                  throws IOException

Description copied from class: `IndexReader`
Expert: visits the fields of a stored document, for custom processing/loading of each field. If you simply want to load all fields, use `IndexReader.document(int)`. If you want to load a subset, use `DocumentStoredFieldVisitor`.

Specified by:
  `document` in class `IndexReader`
Throws:
  `IOException`

#### getLiveDocs

    public Bits getLiveDocs()

Description copied from class: `AtomicReader`
Returns the `Bits` representing live (not deleted) docs. A set bit indicates the doc ID has not been deleted. If this method returns null it means there are no deleted documents (all documents are live). The returned instance has been safely published for use by multiple threads without additional synchronization.

Specified by:
  `getLiveDocs` in class `AtomicReader`

#### getFieldInfos

    public FieldInfos getFieldInfos()

Description copied from class: `AtomicReader`
Get the `FieldInfos` describing all fields in this reader.

Specified by:
  `getFieldInfos` in class `AtomicReader`

#### hasDeletions

    public boolean hasDeletions()

Description copied from class: `IndexReader`
Returns true if any documents have been deleted

Specified by:
  `hasDeletions` in class `IndexReader`

#### getCoreCacheKey

    public Object getCoreCacheKey()

Description copied from class: `IndexReader`
Expert: Returns a key for this IndexReader, so FieldCache/CachingWrapperFilter can find it again. This key must not have equals()/hashCode() methods, so "equals" means "identical".

Overrides:
  `getCoreCacheKey` in class `IndexReader`

#### getCombinedCoreAndDeletesKey

    public Object getCombinedCoreAndDeletesKey()

Description copied from class: `IndexReader`
Expert: Returns a key for this IndexReader that also includes deletions, so FieldCache/CachingWrapperFilter can find it again. This key must not have equals()/hashCode() methods, so "equals" means "identical".

Overrides:
  `getCombinedCoreAndDeletesKey` in class `IndexReader`

#### doClose

    protected void doClose()
                    throws IOException

Description copied from class: `IndexReader`
Implements close.

Specified by:
  `doClose` in class `IndexReader`
Throws:
  `IOException`